Index: uspace/lib/softfloat/include/other.h
===================================================================
--- uspace/lib/softfloat/include/other.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/other.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -30,5 +30,5 @@
  * @{
  */
-/** @file
+/** @file Other functions (power, complex).
  */
 
Index: uspace/lib/softfloat/include/sftypes.h
===================================================================
--- uspace/lib/softfloat/include/sftypes.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/sftypes.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Floating point types and constants.
  */
 
@@ -77,11 +78,37 @@
 } float64;
 
-#define FLOAT32_MAX  0x7f800000
-#define FLOAT32_MIN  0xff800000
-#define FLOAT64_MAX
-#define FLOAT64_MIN
+typedef union {
+	long double ld;
+	struct {
+#if defined(__BE__)
+		uint64_t hi;
+		uint64_t lo;
+#elif defined(__LE__)
+		uint64_t lo;
+		uint64_t hi;
+#else
+	#error Unknown endianess
+#endif
+	} binary;
+
+	struct {
+#if defined(__BE__)
+		uint64_t sign : 1;
+		uint64_t exp : 15;
+		uint64_t frac_hi : 48;
+		uint64_t frac_lo : 64;
+#elif defined(__LE__)
+		uint64_t frac_lo : 64;
+		uint64_t frac_hi : 48;
+		uint64_t exp : 15;
+		uint64_t sign : 1;
+#else
+	#error Unknown endianess
+#endif
+	} parts __attribute__ ((packed));
+} float128;
 
 /*
- * For recognizing NaNs or infinity use isFloat32NaN and is Float32Inf,
+ * For recognizing NaNs or infinity use specialized comparison functions,
  * comparing with these constants is not sufficient.
  */
@@ -95,16 +122,30 @@
 #define FLOAT64_INF     0x7FF0000000000000ll
 
-#define FLOAT32_FRACTION_SIZE  23
-#define FLOAT64_FRACTION_SIZE  52
+#define FLOAT128_NAN_HI     0x7FFF800000000000ll
+#define FLOAT128_NAN_LO     0x0000000000000001ll
+#define FLOAT128_SIGNAN_HI  0x7FFF000000000000ll
+#define FLOAT128_SIGNAN_LO  0x0000000000000001ll
+#define FLOAT128_INF_HI     0x7FFF000000000000ll
+#define FLOAT128_INF_LO     0x0000000000000000ll
 
-#define FLOAT32_HIDDEN_BIT_MASK  0x800000
-#define FLOAT64_HIDDEN_BIT_MASK  0x10000000000000ll
+#define FLOAT32_FRACTION_SIZE   23
+#define FLOAT64_FRACTION_SIZE   52
+#define FLOAT128_FRACTION_SIZE 112
+#define FLOAT128_FRAC_HI_SIZE   48
+#define FLOAT128_FRAC_LO_SIZE   64
+
+#define FLOAT32_HIDDEN_BIT_MASK      0x800000
+#define FLOAT64_HIDDEN_BIT_MASK      0x10000000000000ll
+#define FLOAT128_HIDDEN_BIT_MASK_HI  0x1000000000000ll
+#define FLOAT128_HIDDEN_BIT_MASK_LO  0x0000000000000000ll
 
 #define FLOAT32_MAX_EXPONENT  0xFF
 #define FLOAT64_MAX_EXPONENT  0x7FF
+#define FLOAT128_MAX_EXPONENT 0x7FFF
 
 #define FLOAT32_BIAS  0x7F
 #define FLOAT64_BIAS  0x3FF
 #define FLOAT80_BIAS  0x3FFF
+#define FLOAT128_BIAS 0x3FFF
 
 #endif
Index: uspace/lib/softfloat/include/softfloat.h
===================================================================
--- uspace/lib/softfloat/include/softfloat.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/softfloat.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Softfloat API.
  */
 
@@ -156,4 +157,5 @@
 extern int __ltdf2(double, double);
 extern int __lttf2(long double, long double);
+
 extern int __lesf2(float, float);
 extern int __ledf2(double, double);
@@ -166,4 +168,44 @@
 /* Not implemented yet */
 extern float __powisf2(float, int);
+extern double __powidf2 (double, int);
+extern long double __powitf2 (long double, int);
+extern long double __powixf2 (long double, int);
+
+
+
+/* SPARC quadruple-precision wrappers */
+
+extern void _Qp_add(long double *, long double *, long double *);
+extern void _Qp_sub(long double *, long double *, long double *);
+extern void _Qp_mul(long double *, long double *, long double *);
+extern void _Qp_div(long double *, long double *, long double *);
+extern void _Qp_neg(long double *, long double *);
+
+extern void _Qp_stoq(long double *, float);
+extern void _Qp_dtoq(long double *, double);
+extern float _Qp_qtos(long double *);
+extern double _Qp_qtod(long double *);
+
+extern int _Qp_qtoi(long double *);
+extern unsigned int _Qp_qtoui(long double *);
+extern long _Qp_qtox(long double *);
+extern unsigned long _Qp_qtoux(long double *);
+
+extern void _Qp_itoq(long double *, int);
+extern void _Qp_uitoq(long double *, unsigned int);
+extern void _Qp_xtoq(long double *, long);
+extern void _Qp_uxtoq(long double *, unsigned long);
+
+extern int _Qp_cmp(long double *, long double *);
+extern int _Qp_cmpe(long double *, long double *);
+extern int _Qp_feq(long double *, long double *);
+extern int _Qp_fge(long double *, long double *);
+extern int _Qp_fgt(long double *, long double *);
+extern int _Qp_fle(long double*, long double *);
+extern int _Qp_flt(long double *, long double *);
+extern int _Qp_fne(long double *, long double *);
+
+/* Not implemented yet */
+extern void _Qp_sqrt(long double *, long double *);
 
 #endif
Index: uspace/lib/softfloat/include/sub.h
===================================================================
--- uspace/lib/softfloat/include/sub.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softfloat/include/sub.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2005 Josef Cejka
+ * Copyright (c) 2011 Petr Koupy
  * All rights reserved.
  *
@@ -30,5 +31,5 @@
  * @{
  */
-/** @file
+/** @file Substraction functions.
  */
 
@@ -38,4 +39,5 @@
 extern float32 subFloat32(float32, float32);
 extern float64 subFloat64(float64, float64);
+extern float128 subFloat128(float128, float128);
 
 #endif
Index: uspace/lib/softint/Makefile
===================================================================
--- uspace/lib/softint/Makefile	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/lib/softint/Makefile	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -35,6 +35,8 @@
 
 SOURCES = \
+	generic/comparison.c \
 	generic/division.c \
-	generic/multiplication.c
+	generic/multiplication.c \
+	generic/shift.c
 
 include $(USPACE_PREFIX)/Makefile.common
Index: uspace/lib/softint/generic/comparison.c
===================================================================
--- uspace/lib/softint/generic/comparison.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
+++ uspace/lib/softint/generic/comparison.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup softint
+ * @{
+ */
+/**
+ * @file Signed and unsigned comparisons.
+ */
+
+#include <comparison.h>
+#include <lltype.h>
+
+#define LESSER  0;
+#define EQUAL   1;
+#define GREATER 2;
+
+int __cmpdi2 (long long a, long long b)
+{
+	union lltype lla;
+	union lltype llb;
+
+	lla.s_whole = a;
+	llb.s_whole = b;
+
+	if (lla.s_half[HI] < llb.s_half[HI]) {
+		return LESSER;
+	} else if (lla.s_half[HI] > llb.s_half[HI]) {
+		return GREATER;
+	} else {
+		if (lla.u_half[LO] < llb.u_half[LO]) {
+			return LESSER;
+		} else if (lla.u_half[LO] > llb.u_half[LO]) {
+			return GREATER;
+		} else {
+			return EQUAL;
+		}
+	}
+}
+
+int __ucmpdi2 (unsigned long long a, unsigned long long b)
+{
+	union lltype lla;
+	union lltype llb;
+
+	lla.u_whole = a;
+	llb.u_whole = b;
+
+	if (lla.u_half[HI] < llb.u_half[HI]) {
+		return LESSER;
+	} else if (lla.u_half[HI] > llb.u_half[HI]) {
+		return GREATER;
+	} else {
+		if (lla.u_half[LO] < llb.u_half[LO]) {
+			return LESSER;
+		} else if (lla.u_half[LO] > llb.u_half[LO]) {
+			return GREATER;
+		} else {
+			return EQUAL;
+		}
+	}
+}
+
+/** @}
+ */
Index: uspace/lib/softint/generic/shift.c
===================================================================
--- uspace/lib/softint/generic/shift.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
+++ uspace/lib/softint/generic/shift.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -0,0 +1,126 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup softint
+ * @{
+ */
+/**
+ * @file Logical and arithmetic shifts.
+ */
+
+#include <shift.h>
+#include <lltype.h>
+
+long long __ashldi3 (long long val, int shift)
+{
+	union lltype ll;
+
+	ll.s_whole = val;
+	
+	if (shift <= 0) {
+		return ll.s_whole;
+	}
+	
+	if (shift >= (int) WHOLE_BIT_CNT) {
+		ll.u_half[HI] = 0;
+		ll.u_half[LO] = 0;
+		return ll.s_whole;
+	}
+
+	if (shift >= (int) HALF_BIT_CNT) {
+		ll.u_half[HI] = ll.u_half[LO] << (shift - HALF_BIT_CNT);
+		ll.u_half[LO] = 0;
+	} else {
+		ll.u_half[HI] <<= shift;
+		ll.u_half[HI] |= ll.u_half[LO] >> (HALF_BIT_CNT - shift);
+		ll.u_half[LO] <<= shift;
+	}
+
+	return ll.s_whole;
+}
+
+long long __ashrdi3 (long long val, int shift)
+{
+	union lltype ll;
+
+	ll.s_whole = val;
+
+	if (shift <= 0) {
+		return ll.s_whole;
+	}
+
+	long fill = ll.s_half[HI] >> (HALF_BIT_CNT - 1);
+
+	if (shift >= (int) WHOLE_BIT_CNT) {
+		ll.s_half[HI] = fill;
+		ll.s_half[LO] = fill;
+		return ll.s_whole;
+	}
+
+	if (shift >= (int) HALF_BIT_CNT) {
+		ll.s_half[LO] = ll.s_half[HI] >> (shift - HALF_BIT_CNT);
+		ll.s_half[HI] = fill;
+	} else {
+		ll.u_half[LO] >>= shift;
+		ll.u_half[LO] |= ll.u_half[HI] << (HALF_BIT_CNT - shift);
+		ll.s_half[HI] >>= shift;
+	}
+
+	return ll.s_whole;
+}
+
+long long __lshrdi3 (long long val, int shift)
+{
+	union lltype ll;
+
+	ll.s_whole = val;
+
+	if (shift <= 0) {
+		return ll.s_whole;
+	}
+
+	if (shift >= (int) WHOLE_BIT_CNT) {
+		ll.u_half[HI] = 0;
+		ll.u_half[LO] = 0;
+		return ll.s_whole;
+	}
+
+	if (shift >= (int) HALF_BIT_CNT) {
+		ll.u_half[LO] = ll.u_half[HI] >> (shift - HALF_BIT_CNT);
+		ll.u_half[HI] = 0;
+	} else {
+		ll.u_half[LO] >>= shift;
+		ll.u_half[LO] |= ll.u_half[HI] << (HALF_BIT_CNT - shift);
+		ll.u_half[HI] >>= shift;
+	}
+
+	return ll.s_whole;
+}
+
+/** @}
+ */
Index: uspace/lib/softint/include/comparison.h
===================================================================
--- uspace/lib/softint/include/comparison.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
+++ uspace/lib/softint/include/comparison.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup softint
+ * @{
+ */
+/**
+ * @file Signed and unsigned comparisons.
+ */
+
+#ifndef __SOFTINT_COMPARISON_H__
+#define __SOFTINT_COMPARISON_H__
+
+/* Signed comparison (a < b => 0, a == b => 1, a > b => 2). */
+int __cmpdi2 (long long a, long long b);
+
+/* Unsigned comparison (a < b => 0, a == b => 1, a > b => 2). */
+int __ucmpdi2 (unsigned long long a, unsigned long long b);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/softint/include/lltype.h
===================================================================
--- uspace/lib/softint/include/lltype.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
+++ uspace/lib/softint/include/lltype.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup softint
+ * @{
+ */
+/**
+ * @file Abstraction over 64-bit integral type to allow simple manipulation.
+ */
+
+#ifndef __SOFTINT_LLTYPE_H__
+#define __SOFTINT_LLTYPE_H__
+
+#include <stdint.h>
+
+#define HALF_BIT_CNT (sizeof(int32_t) * sizeof(char))
+#define WHOLE_BIT_CNT (sizeof(int64_t) * sizeof(char))
+
+#ifdef __BE__
+	#define LO 1
+	#define HI 0
+#else
+	#define LO 0
+	#define HI 1
+#endif
+
+union lltype {
+	int64_t s_whole;
+	uint64_t u_whole;
+	int32_t s_half[2];
+	uint32_t u_half[2];
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/softint/include/shift.h
===================================================================
--- uspace/lib/softint/include/shift.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
+++ uspace/lib/softint/include/shift.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2011 Petr Koupy
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup softint
+ * @{
+ */
+/**
+ * @file Logical and arithmetic shifts.
+ */
+
+#ifndef __SOFTINT_SHIFT_H__
+#define __SOFTINT_SHIFT_H__
+
+/* Arithmetic/logical shift left. */
+long long __ashldi3 (long long val, int shift);
+
+/* Arithmetic shift right. */
+long long __ashrdi3 (long long val, int shift);
+
+/* Logical shift right. */
+long long __lshrdi3 (long long val, int shift);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/bd/ata_bd/ata_bd.c
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/ata_bd/ata_bd.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -57,5 +57,5 @@
 #include <stdint.h>
 #include <str.h>
-#include <devmap.h>
+#include <loc.h>
 #include <sys/types.h>
 #include <inttypes.h>
@@ -176,5 +176,5 @@
 		
 		snprintf(name, 16, "%s/ata%udisk%d", NAMESPACE, ctl_num, i);
-		rc = devmap_device_register(name, &disk[i].devmap_handle);
+		rc = loc_service_register(name, &disk[i].service_id);
 		if (rc != EOK) {
 			printf(NAME ": Unable to register device %s.\n", name);
@@ -244,5 +244,5 @@
 	int rc;
 
-	rc = devmap_driver_register(NAME, ata_bd_connection);
+	rc = loc_server_register(NAME, ata_bd_connection);
 	if (rc < 0) {
 		printf(NAME ": Unable to register driver.\n");
@@ -277,5 +277,5 @@
 	ipc_call_t call;
 	sysarg_t method;
-	devmap_handle_t dh;
+	service_id_t dsid;
 	size_t comm_size;	/**< Size of the communication area. */
 	unsigned int flags;
@@ -285,11 +285,11 @@
 	int disk_id, i;
 
-	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
+	/* Get the device service ID. */
+	dsid = IPC_GET_ARG1(*icall);
 
 	/* Determine which disk device is the client connecting to. */
 	disk_id = -1;
 	for (i = 0; i < MAX_DISKS; i++)
-		if (disk[i].devmap_handle == dh)
+		if (disk[i].service_id == dsid)
 			disk_id = i;
 
Index: uspace/srv/bd/ata_bd/ata_bd.h
===================================================================
--- uspace/srv/bd/ata_bd/ata_bd.h	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/ata_bd/ata_bd.h	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -116,5 +116,5 @@
 
 	fibril_mutex_t lock;
-	devmap_handle_t devmap_handle;
+	service_id_t service_id;
 } disk_t;
 
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -45,5 +45,5 @@
 #include <as.h>
 #include <fibril_synch.h>
-#include <devmap.h>
+#include <loc.h>
 #include <sys/types.h>
 #include <sys/typefmt.h>
@@ -61,5 +61,5 @@
 static FILE *img;
 
-static devmap_handle_t devmap_handle;
+static service_id_t service_id;
 static fibril_mutex_t dev_lock;
 
@@ -117,5 +117,5 @@
 		return -1;
 
-	rc = devmap_device_register(device_name, &devmap_handle);
+	rc = loc_service_register(device_name, &service_id);
 	if (rc != EOK) {
 		printf(NAME ": Unable to register device '%s'.\n",
@@ -142,5 +142,5 @@
 	long img_size;
 
-	rc = devmap_driver_register(NAME, file_bd_connection);
+	rc = loc_server_register(NAME, file_bd_connection);
 	if (rc < 0) {
 		printf(NAME ": Unable to register driver.\n");
Index: uspace/srv/bd/gxe_bd/gxe_bd.c
===================================================================
--- uspace/srv/bd/gxe_bd/gxe_bd.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/gxe_bd/gxe_bd.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -43,5 +43,5 @@
 #include <as.h>
 #include <fibril_synch.h>
-#include <devmap.h>
+#include <loc.h>
 #include <sys/types.h>
 #include <errno.h>
@@ -92,5 +92,5 @@
 static gxe_bd_t *dev;
 
-static devmap_handle_t devmap_handle[MAX_DISKS];
+static service_id_t service_id[MAX_DISKS];
 
 static fibril_mutex_t dev_lock[MAX_DISKS];
@@ -126,5 +126,5 @@
 	char name[16];
 
-	rc = devmap_driver_register(NAME, gxe_bd_connection);
+	rc = loc_server_register(NAME, gxe_bd_connection);
 	if (rc < 0) {
 		printf(NAME ": Unable to register driver.\n");
@@ -142,5 +142,5 @@
 	for (i = 0; i < MAX_DISKS; i++) {
 		snprintf(name, 16, "%s/disk%d", NAMESPACE, i);
-		rc = devmap_device_register(name, &devmap_handle[i]);
+		rc = loc_service_register(name, &service_id[i]);
 		if (rc != EOK) {
 			printf(NAME ": Unable to register device %s.\n", name);
@@ -159,5 +159,5 @@
 	ipc_call_t call;
 	sysarg_t method;
-	devmap_handle_t dh;
+	service_id_t dsid;
 	unsigned int flags;
 	int retval;
@@ -167,10 +167,10 @@
 
 	/* Get the device handle. */
-	dh = IPC_GET_ARG1(*icall);
+	dsid = IPC_GET_ARG1(*icall);
 
 	/* Determine which disk device is the client connecting to. */
 	disk_id = -1;
 	for (i = 0; i < MAX_DISKS; i++)
-		if (devmap_handle[i] == dh)
+		if (service_id[i] == dsid)
 			disk_id = i;
 
Index: uspace/srv/bd/part/guid_part/guid_part.c
===================================================================
--- uspace/srv/bd/part/guid_part/guid_part.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/part/guid_part/guid_part.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -51,10 +51,10 @@
 #include <as.h>
 #include <fibril_synch.h>
-#include <devmap.h>
+#include <loc.h>
 #include <sys/types.h>
 #include <sys/typefmt.h>
 #include <inttypes.h>
 #include <libblock.h>
-#include <devmap.h>
+#include <loc.h>
 #include <errno.h>
 #include <bool.h>
@@ -81,6 +81,6 @@
 	/** Number of blocks */
 	aoff64_t length;
-	/** Device representing the partition (outbound device) */
-	devmap_handle_t dev;
+	/** Service representing the partition (outbound device) */
+	service_id_t dsid;
 	/** Points to next partition structure. */
 	struct part *next;
@@ -90,5 +90,5 @@
 
 /** Partitioned device (inbound device) */
-static devmap_handle_t indev_handle;
+static service_id_t indev_sid;
 
 /** List of partitions. This structure is an empty head. */
@@ -129,9 +129,9 @@
 	int i;
 	char *name;
-	devmap_handle_t dev;
+	service_id_t dsid;
 	uint64_t size_mb;
 	part_t *part;
 
-	rc = devmap_device_get_handle(dev_name, &indev_handle, 0);
+	rc = loc_service_get_id(dev_name, &indev_sid, 0);
 	if (rc != EOK) {
 		printf(NAME ": could not resolve device `%s'.\n", dev_name);
@@ -139,5 +139,5 @@
 	}
 
-	rc = block_init(EXCHANGE_SERIALIZE, indev_handle, 2048);
+	rc = block_init(EXCHANGE_SERIALIZE, indev_sid, 2048);
 	if (rc != EOK)  {
 		printf(NAME ": could not init libblock.\n");
@@ -147,5 +147,5 @@
 	/* Determine and verify block size. */
 
-	rc = block_get_bsize(indev_handle, &block_size);
+	rc = block_get_bsize(indev_sid, &block_size);
 	if (rc != EOK) {
 		printf(NAME ": error getting block size.\n");
@@ -163,8 +163,8 @@
 		return rc;
 
-	/* Register the driver with device mapper. */
-	rc = devmap_driver_register(NAME, gpt_connection);
+	/* Register server with location service. */
+	rc = loc_server_register(NAME, gpt_connection);
 	if (rc != EOK) {
-		printf(NAME ": Unable to register driver.\n");
+		printf(NAME ": Unable to register server.\n");
 		return rc;
 	}
@@ -188,7 +188,7 @@
 			return ENOMEM;
 
-		rc = devmap_device_register(name, &dev);
+		rc = loc_service_register(name, &dsid);
 		if (rc != EOK) {
-			printf(NAME ": Unable to register device %s.\n", name);
+			printf(NAME ": Unable to register service %s.\n", name);
 			return rc;
 		}
@@ -199,5 +199,5 @@
 		    "%" PRIuOFF64 " MB.\n", name, part->length, size_mb);
 
-		part->dev = dev;
+		part->dsid = dsid;
 		free(name);
 
@@ -228,5 +228,5 @@
 	}
 
-	rc = block_read_direct(indev_handle, GPT_HDR_BA, 1, gpt_hdr);
+	rc = block_read_direct(indev_sid, GPT_HDR_BA, 1, gpt_hdr);
 	if (rc != EOK) {
 		printf(NAME ": Failed reading GPT header block.\n");
@@ -256,5 +256,5 @@
 	}
 
-	rc = block_read_direct(indev_handle, ba, bcnt, etable);
+	rc = block_read_direct(indev_sid, ba, bcnt, etable);
 	if (rc != EOK) {
 		printf(NAME ": Failed reading GPT entries.\n");
@@ -303,5 +303,5 @@
 	}
 
-	part->dev = 0;
+	part->dsid = 0;
 	part->next = NULL;
 }
@@ -314,5 +314,5 @@
 	ipc_call_t call;
 	sysarg_t method;
-	devmap_handle_t dh;
+	service_id_t dh;
 	unsigned int flags;
 	int retval;
@@ -330,5 +330,5 @@
 	 */
 	part = plist_head.next;
-	while (part != NULL && part->dev != dh)
+	while (part != NULL && part->dsid != dh)
 		part = part->next;
 
@@ -410,5 +410,5 @@
 		return ELIMIT;
 
-	return block_read_direct(indev_handle, gba, cnt, buf);
+	return block_read_direct(indev_sid, gba, cnt, buf);
 }
 
@@ -421,5 +421,5 @@
 		return ELIMIT;
 
-	return block_write_direct(indev_handle, gba, cnt, buf);
+	return block_write_direct(indev_sid, gba, cnt, buf);
 }
 
Index: uspace/srv/bd/part/mbr_part/mbr_part.c
===================================================================
--- uspace/srv/bd/part/mbr_part/mbr_part.c	(revision e898296dccf506e7ddbab26d669ed48d920be059)
+++ uspace/srv/bd/part/mbr_part/mbr_part.c	(revision 3e01316fd558e3235487a9cfe2a4fe29615ff69a)
@@ -61,10 +61,9 @@
 #include <as.h>
 #include <fibril_synch.h>
-#include <devmap.h>
+#include <loc.h>
 #include <sys/types.h>
 #include <sys/typefmt.h>
 #include <inttypes.h>
 #include <libblock.h>
-#include <devmap.h>
 #include <errno.h>
 #include <bool.h>
@@ -100,5 +99,5 @@
 	aoff64_t length;
 	/** Device representing the partition (outbound device) */
-	devmap_handle_t dev;
+	service_id_t dsid;
 	/** Points to next partition structure. */
 	struct part *next;
@@ -141,5 +140,5 @@
 
 /** Partitioned device (inbound device) */
-static devmap_handle_t indev_handle;
+static service_id_t indef_sid;
 
 /** List of partitions. This structure is an empty head. */
@@ -180,9 +179,9 @@
 	int i;
 	char *name;
-	devmap_handle_t dev;
+	service_id_t dsid;
 	uint64_t size_mb;
 	part_t *part;
 
-	rc = devmap_device_get_handle(dev_name, &indev_handle, 0);
+	rc = loc_service_get_id(dev_name, &indef_sid, 0);
 	if (rc != EOK) {
 		printf(NAME ": could not resolve device `%s'.\n", dev_name);
@@ -190,5 +189,5 @@
 	}
 
-	rc = block_init(EXCHANGE_SERIALIZE, indev_handle, 2048);
+	rc = block_init(EXCHANGE_SERIALIZE, indef_sid, 2048);
 	if (rc != EOK)  {
 		printf(NAME ": could not init libblock.\n");
@@ -198,5 +197,5 @@
 	/* Determine and verify block size. */
 
-	rc = block_get_bsize(indev_handle, &block_size);
+	rc = block_get_bsize(indef_sid, &block_size);
 	if (rc != EOK) {
 		printf(NAME ": error getting block size.\n");
@@ -214,8 +213,8 @@
 		return rc;
 
-	/* Register the driver with device mapper. */
-	rc = devmap_driver_register(NAME, mbr_connection);
+	/* Register server with location service. */
+	rc = loc_server_register(NAME, mbr_connection);
 	if (rc != EOK) {
-		printf(NAME ": Unable to register driver.\n");
+		printf(NAME ": Unable to register server.\n");
 		return rc;
 	}
@@ -239,7 +238,7 @@
 			return ENOMEM;
 
-		rc = devmap_device_register(name, &dev);
+		rc = loc_service_register(name, &dsid);
 		if (rc != EOK) {
-			printf(NAME ": Unable to register device %s.\n", name);
+			printf(NAME ": Unable to register service %s.\n", name);
 			return rc;
 		}
@@ -250,5 +249,5 @@
 		    "%" PRIu64 " MB.\n", name, part->length, size_mb);
 
-		part->dev = dev;
+		part->dsid = dsid;
 		free(name);
 
@@ -281,5 +280,5 @@
 	 */
 
-	rc = block_read_direct(indev_handle, 0, 1, brb);
+	rc = block_read_direct(indef_sid, 0, 1, brb);
 	if (rc != EOK) {
 		printf(NAME ": Failed reading MBR block.\n");
@@ -332,5 +331,5 @@
 		 */
 		ba = cp.start_addr;
-		rc = block_read_direct(indev_handle, ba, 1, brb);
+		rc = block_read_direct(indef_sid, ba, 1, brb);
 		if (rc != EOK) {
 			printf(NAME ": Failed reading EBR block at %"
@@ -381,5 +380,5 @@
 	part->present = (pte->ptype != PT_UNUSED) ? true : false;
 
-	part->dev = 0;
+	part->dsid = 0;
 	part->next = NULL;
 }
@@ -392,5 +391,5 @@
 	ipc_call_t call;
 	sysarg_t method;
-	devmap_handle_t dh;
+	service_id_t dh;
 	unsigned int flags;
 	int retval;
@@ -408,5 +407,5 @@
 	 */
 	part = plist_head.next;
-	while (part != NULL && part->dev != dh)
+	while (part != NULL && part->dsid != dh)
 		part = part->next;
 
@@ -488,5 +487,5 @@
 		return ELIMIT;
 
-	return block_read_direct(indev_handle, gba, cnt, buf);
+	return block_read_direct(indef_sid, gba, cnt, buf);
 }
 
@@ -499,5 +498,5 @@
 		return ELIMIT;
 
-	return block_write_direct(indev_handle, gba, cnt, buf);
+	return block_write_direct(indef_sid, gba, cnt, buf);
 }
 
